=== modeling/CMakeLists.txt ===
#--------------------------------------------
# Modeling extension project
#--------------------------------------------
# Mini find CamiTK inside SDK
set(CAMITK_DIR ${CMAKE_BINARY_DIR})
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CAMITK_DIR}/share/${CAMITK_SHORT_VERSION_STRING}/cmake)
include(CamiTKConfig)

# Sofa support is defined in separate files
include(SofaSupport.cmake)
# uncomment the following line for old versions of sofa: at your own risk!
#include(SofaLegacySupport.cmake) 

# For packaging on windows, dash cannot be used as separator
# => replace it by underscore
if (PACKAGING_NSIS)
    set(TARGET_NAME_SEPARATOR _)
else()
    set(TARGET_NAME_SEPARATOR -)
endif()

camitk_extension_project(NAME "modeling"
                         CONTACT "Celine.Fouard@imag.fr,Emmanuel.Promayon@imag.fr"
                         DESCRIPTION "The modeling CamiTK Extension Project contains all the action and component extensions that are useful for biomechanical processing. It provides the LML, PML and MML libraries, and the related components and actions."
)
