=== modeling/applications/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add an application, just add a subdirectory (the application name is the 
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_application() macro appropriately

# Find applications
get_subdirectories(APPLICATIONS_LIST)

# -- Define for subdirectory usage (test and tools)
# create some useful variables for subdirectories applications
# This lines have to be below the camitk_application macro call
set(LML_DEPENDENCY library${TARGET_NAME_SEPARATOR}lml)
set(LMLSCHEMA_DEPENDENCY library${TARGET_NAME_SEPARATOR}lmlschema)
set(LML_DEPENDENCIES ${LML_DEPENDENCY} ${LMLSCHEMA_DEPENDENCY})
set(PML_DEPENDENCY library${TARGET_NAME_SEPARATOR}pml)
set(PMLSCHEMA_DEPENDENCY library${TARGET_NAME_SEPARATOR}pmlschema)
set(PML_DEPENDENCIES ${PML_DEPENDENCY} ${PMLSCHEMA_DEPENDENCY})
set(PMLLML_DEPENDENCY ${PML_DEPENDENCY} ${PMLSCHEMA_DEPENDENCY} ${LML_DEPENDENCY} ${LMLSCHEMA_DEPENDENCY})

# --- add every given application
foreach(APPLICATION_NAME ${APPLICATIONS_LIST})
   add_subdirectory(${APPLICATION_NAME})
endforeach()
