=== sdk/doc/CMakeLists.txt ===
camitk_add_subdirectory(resources/actions)
