=== imaging/components/dicom/CMakeLists.txt ===
camitk_extension(   COMPONENT_EXTENSION
                    NEEDS_GDCM
                    CEP_NAME CEP_IMAGING
                    DESCRIPTION "This allows one to read a single DICOM image file (.dcm) using the library GDCM 2.2.x"
                    TEST_APPLICATION ${APPLICATION_TEST_COMPONENT}
                    INSTALL_ALL_HEADERS
)
