=== debian/changelog ===
camitk (4.0.4-2ubuntu4) bionic; urgency=medium

  * No-change rebuild for libxerces soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 16 Nov 2017 13:05:00 +0000

camitk (4.0.4-2ubuntu3) artful; urgency=medium

  * No-change rebuild against libgdcm2.8

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 10 Aug 2017 19:18:19 +0000

camitk (4.0.4-2ubuntu2) zesty; urgency=medium

  * Tests: remove one space, at that point it's a newline still..

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Mon, 20 Mar 2017 11:10:48 +0200

camitk (4.0.4-2ubuntu1) zesty; urgency=medium

  * Tests: clean config output from QStandardPaths informative text.

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Fri, 17 Mar 2017 11:29:19 +0200

camitk (4.0.4-2) unstable; urgency=medium

  * Updated email address
  * wizard tests gained verbosity
  * Start Xvfb server first + update test dependencies

 -- Emmanuel Promayon <Emmanuel.Promayon@univ-grenoble-alpes.fr>  Fri, 20 Jan 2017 20:23:05 +0000

camitk (4.0.4-1) unstable; urgency=medium

  [ Emmanuel Promayon ]
  * New upstream version 4.0.4
  * libdevel needs most of the build depends (needed for ci)

  [ Andreas Tille ]
  * debhelper 10 (drop --parallel from d/rules)
  * d/watch: version=4
  * hardening=+all

 -- Emmanuel Promayon <Emmanuel.Promayon@imag.fr>  Fri, 02 Dec 2016 06:01:44 +0000
